#include "unicycle.h"									
                                      // This is the 3D file we will load.



char filnamn[antalObjekt][30] = {{"models/stang.ASE"},{"models/hjul.ASE"},{"models/figur.ASE"},{"models/figur2.ASE"}};

UINT g_texture[MAX_TEXTURES]= {0};	
UINT h_texture[MAX_TEXTURES]= {0};	

UINT texturer[antalObjekt][MAX_TEXTURES] = {{g_texture[MAX_TEXTURES]},{ h_texture[MAX_TEXTURES]}}; 					// This holds the texture info, referenced by an ID

ase g_LoadASE;
										// This is ASE class.  This should go in a good model class.
t3DModel h_3DModel;
t3DModel g_3DModel;


t3DModel modeller[antalObjekt] = {h_3DModel,g_3DModel};	

int g_ViewMode = GL_TRIANGLES;					// We want the default drawing mode to be normal

/////	This creates a texture in OpenGL that we can texture map
void load::CreateTexture(UINT textureArray[], LPSTR strFileName, int textureID)
{
	AUX_RGBImageRec *pBitmap = NULL;
	
	if(!strFileName)									// Return from the function if no file name was passed in
		return;

	pBitmap = auxDIBImageLoad(strFileName);				// Load the bitmap and store the data
	
	if(pBitmap == NULL)									// If we can't load the file, quit!
		exit(0);

	// Generate a texture with the associative texture ID stored in the array
	glGenTextures(1, &textureArray[textureID]);

	// This sets the alignment requirements for the start of each pixel row in memory.
	glPixelStorei (GL_UNPACK_ALIGNMENT, 1);

	// Bind the texture to the texture arrays index and init the texture
	glBindTexture(GL_TEXTURE_2D, textureArray[textureID]);

	// Build Mipmaps (builds different versions of the picture for distances - looks better)
	gluBuild2DMipmaps(GL_TEXTURE_2D, 3, pBitmap->sizeX, pBitmap->sizeY, GL_RGB, GL_UNSIGNED_BYTE, pBitmap->data);

	// Lastly, we need to tell OpenGL the quality of our texture map.  GL_LINEAR_MIPMAP_LINEAR
	// is the smoothest.  GL_LINEAR_MIPMAP_NEAREST is faster than GL_LINEAR_MIPMAP_LINEAR, 
	// but looks blochy and pixilated.  Good for slower computers though.  	
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR_MIPMAP_LINEAR);

	// Now we need to free the bitmap data that we loaded since openGL stored it as a texture

	if (pBitmap)										// If we loaded the bitmap
	{
		if (pBitmap->data)								// If there is texture data
		{
			free(pBitmap->data);						// Free the texture data, we don't need it anymore
		}

		free(pBitmap);									// Free the bitmap structure
	}
}

	
void load::Init()
	{

	for(int nr = 0; nr < antalObjekt; nr++)
	{
	
	g_LoadASE.ImportASE(&modeller[nr], filnamn[nr]);
	// Go through all the materials
	for(int i = 0; i < modeller[nr].numOfMaterials; i++)
	{
		// Check to see if there is a file name to load in this material
		if(strlen(modeller[nr].pMaterials[i].strFile) > 0)
		{
			// Use the name of the texture file to load the bitmap, with a texture ID (i).
			// We pass in our global texture arrow, the name of the texture, and an ID to reference it.	
			CreateTexture(texturer[nr], modeller[nr].pMaterials[i].strFile, i);			
		}

		// Set the texture ID for this material
		modeller[nr].pMaterials[i].texureId = i;
	}
}

}
/*
void load::DeInit()
{
	// When we are done, we need to free all the model data
	// Go through all the objects in the scene
	for(int i = 0; i < g_3DModel.numOfObjects; i++)
	{
		// Free the faces, normals, vertices, and texture coordinates.
		delete [] g_3DModel.pObject[i].pFaces;
		delete [] g_3DModel.pObject[i].pNormals;
		delete [] g_3DModel.pObject[i].pVerts;
		delete [] g_3DModel.pObject[i].pTexVerts;
	}
}

*/

void load::RenderScene(int nr) 
{
	//if(nr==0)
	//glScalef(0.05f, 0.05f, 0.05f); //glTranslatef(0.0f, -0.9f, -0.9f);
 				

	// Since we know how many objects our model has, go through each of them.
	for(int i = 0; i < modeller[nr].numOfObjects; i++)
	{
		// Make sure we have valid objects just in case. (size() is in the vector class)
		if(modeller[nr].pObject.size() <= 0) break;

		// Get the current object that we are displaying
		t3DObject *pObject = &modeller[nr].pObject[i];
			
		// Check to see if this object has a texture map, if so bind the texture to it.
		if(pObject->bHasTexture) {

			// Turn on texture mapping and turn off color
			glEnable(GL_TEXTURE_2D);

			// Reset the color to normal again
			glColor3ub(255, 0, 0);

			// Bind the texture map to the object by it's materialID
			glBindTexture(GL_TEXTURE_2D, texturer[nr][pObject->materialID]);
		} else {

			// Turn off texture mapping and turn on color
			glDisable(GL_TEXTURE_2D);

			// Reset the color to normal again
			glColor3ub(255, 0, 0);
		}

		// This determines if we are in wireframe or normal mode
		glBegin(g_ViewMode);					// Begin drawing with our selected mode (triangles or lines)

			// Go through all of the faces (polygons) of the object and draw them
			for(int j = 0; j < pObject->numOfFaces; j++)
			{
				// Go through each corner of the triangle and draw it.
				for(int whichVertex = 0; whichVertex < 3; whichVertex++)
				{
					// Get the vertex index for each point of the face
					int vertIndex = pObject->pFaces[j].vertIndex[whichVertex];
			
					// Give OpenGL the normal for this vertex.
					glNormal3f(pObject->pNormals[ vertIndex ].x, pObject->pNormals[ vertIndex ].y, pObject->pNormals[ vertIndex ].z);
				
					// If the object has a texture associated with it, give it a texture coordinate.
					if(pObject->bHasTexture) {

						// Make sure there was a UVW map applied to the object or else it won't have tex coords.
						if(pObject->pTexVerts) {

							// Get the texture coordinate index
							int coordIndex = pObject->pFaces[j].coordIndex[whichVertex];

							// Assign the UV coordinates to the current vertex being rendered
							glTexCoord2f(pObject->pTexVerts[ coordIndex ].x, pObject->pTexVerts[ coordIndex ].y);
						}
					} else {

						if(modeller[nr].pMaterials.size() && pObject->materialID >= 0) 
						{
							// Get and set the color that the object is, since it must not have a texture
							float *pColor = modeller[nr].pMaterials[pObject->materialID].fColor;

							// Assign the current color to this model
							glColor3f(pColor[0], pColor[1], pColor[2]);
						}
					}

					// Pass in the current vertex of the object (Corner of current face)
					glVertex3f(pObject->pVerts[ vertIndex ].x, pObject->pVerts[ vertIndex ].y, pObject->pVerts[ vertIndex ].z);
				}
			}

		glEnd();							// End the drawing
	}

}

