//UNICYCLE.h

/*
This is the only h file. Here are all global variabels 
and constants defined. As well as all classes used by 
the program.
*************************
***Group 13 2005***
*************************
*/

    #ifndef _____UNICYCLE_____
    #define _____UNICYCLE_____
    
    #pragma comment(lib, "opengl32.lib")
    #pragma comment(lib, "glu32.lib")
    

    #include <vector>           
    #include <windows.h>		// Header File For Windows
    #include <gl\gl.h>			// Header File For The OpenGL32 Library
    #include <gl\glu.h>			// Header File For The GLu32 Library
    #include <gl\glaux.h>		// Header File For The Glaux Library
    #include <gl\glfw.h>		// Header File For The Glaux Library
    #include <stdio.h>          // Filehandling
    #include <stdlib.h>
    #include <math.h>            // Math
    #include <fstream>    
    #include <iostream>
    using namespace std;
   
   //Defintions used by the ASE loader class
   //Thanks www.gametutorials.com
   #define OBJECT				"*GEOMOBJECT"			// An object tag for new objects
   #define NUM_VERTEX			"*MESH_NUMVERTEX"		// The number of vertices tag
   #define NUM_FACES			"*MESH_NUMFACES"		// The number of faces tag
   #define NUM_TVERTEX			"*MESH_NUMTVERTEX"		// The number of texture coordinates
   #define VERTEX				"*MESH_VERTEX"			// The list of vertices tag
   #define FACE				"*MESH_FACE"			// The list of faces tag
   #define NORMALS				"*MESH_NORMALS"			// The list of normals tag (If you want)
   #define FACE_NORMAL			"*MESH_FACENORMAL"		// The face normal for the current index
   #define NVERTEX				"*MESH_VERTEXNORMAL"	// The list of vertex normals
   #define TVERTEX				"*MESH_TVERT"			// The texture coordinate index tag
   #define TFACE				"*MESH_TFACE"			// The vertex index tag
   #define TEXTURE				"*BITMAP"				// The file name for the object's texture map
   #define UTILE				"*UVW_U_TILING"			// The U tiling ratio tag
   #define VTILE				"*UVW_V_TILING"			// The V tiling ratio tag
   #define UOFFSET				"*UVW_U_OFFSET"			// The U tile offset tag
   #define VOFFSET				"*UVW_V_OFFSET"			// The V tile offset tag
   #define MATERIAL_ID			"*MATERIAL_REF"			// The material ID tag
   #define MATERIAL_COUNT      "*MATERIAL_COUNT"		// The material count tag
   #define MATERIAL			"*MATERIAL"				// The material tag
   #define MATERIAL_NAME		"*MATERIAL_NAME"		// The material name tag
   #define MATERIAL_COLOR		"*MATERIAL_DIFFUSE"		// The material color tag
   #define MAX_TEXTURES 100
 

     //Global constants
     const float M=23;                        //Mass of vehicle
     const float m=70;                        //Mass of driver
     const float l=1;                         //Lenght of handlebar
     const float axel=1.0f;                   //Lenght of wheel axis
     const float radie = 0.3f;                //Radis of wheels
     const float f=0.4f;                      //Frictional constant 
     const float g=9.81f;                     //Gravitational acceleration
     const float pi = 3.141592654f;           //Aproximation of pi 
     const float radToGrad = 180.0f/pi;       //Transfer constant radians to degree
     const float gradToRad = pi/180.0f;       //Transfer constant degree to radians
     const float dt = 0.01;                   //Time step in simulation
     const int antalObjekt = 4;               //Nmber of models the ASE loader will use



      //Class for handle two dimensional vectors
      //Includes function to calculate the lenght
        class CVector2 
        {
                public:
                float x, y;
                float length() {
                return (sqrt( pow(x,2) + pow(y,2) ));
                }
        };
        
       //Class for handle three dimensional vectors     
       //Includes normalization, dotproduct and lenght functions.
        class CVector3
        {										
                public:							
                float x, y, z;
                void normalize() {
                float L = sqrt( pow(x,2) + pow(y,2) + pow(z,2) );
                x /= L;
                y /= L;
                z /= L;
                }
                float dotProduct(CVector3 tmp) {
                return (x*tmp.x + y*tmp.y + z*tmp.z);
                }
                float length() {
                return (sqrt( pow(x,2) + pow(y,2)+ pow(z,2) ));
                }									
        };
          
        
        
        //Class for drawing objects
        class drawObj
        {
        public:
                drawObj(void);
                ~drawObj(void);
                void drawScene(float p,float v, float radie);
                void drawTextPlane(float x,float y);
        };
        
        //Class to initate OpenGL and draw each frame
        class initGL
        {
            
            //protected:
                        
            public:     bool alive;
                        initGL(void); //konstuerare
                        ~initGL(void); //destruerare
                        void reset();
                        GLvoid ReSizeGLScene(GLsizei, GLsizei);
                        int InitGL(GLvoid);
                        int DrawGLScene(GLvoid);
                        int LoadGLTextures();
        };
        
        //Class for simulate the system
        class object
        {
        public:
                        
        object(void); //konstuerare
        ~object(void); //destruerare            
      
        void resetAll();
        void init();
        float move();
        float bend();
        float rotation();
        float calculateForce();
	   };

        //Class for open a Windows window and allow keyboard inputs
        class openwindow
        {
            
            protected:
                        GLvoid KillGLWindow(GLvoid);
                        BOOL CreateGLWindow(char* title, int width, int height, int bits);//, bool fullscreenflag);
                        int WINAPI WinMain(	HINSTANCE	hInstance,			// Instance
					                        HINSTANCE	hPrevInstance,		// Previous Instance
					                        LPSTR		lpCmdLine,			// Command Line Parameters
					                        int			nCmdShow);			// Window Show State
                        
            
            public:
                        openwindow(void); //konstuerare
                        ~openwindow(void); //destruerare
            
            private:
            
        };
        
        //Class for writing text in OpenGL
        class text
        {
            
            //protected:
                        //funkt&var.
            public:
                        text(void); //konstuerare
                        ~text(void); //destruerare
                        GLvoid BuildFont(GLvoid);
                        GLvoid KillFont(GLvoid);
                        GLvoid glPrint(const char *fmt, ...);
                       // void printtext(void);

        };


//Hereforth comes the initiation of the ASE loader
//It will allow us to load a model created with 3D modeling software
//Thanks www.gametutorials.com

struct tFace
{
	int vertIndex[3];			// indicies for the verts that make up this triangle
	int coordIndex[3];			// indicies for the tex coords to texture this face
};

// This holds the information for a material.  It may be a texture map of a color.
struct tMaterialInfo
{
	char  strName[255];			// The texture name
	char  strFile[255];			// The texture file name (If this is set it's a texture map)
	BYTE  color[3];				// The color of the object (R, G, B) from 0 to 255
	float fColor[3];			// The color of the object (R, G, B) from 0 to 1
	int   texureId;				// the texture ID
	float uTile;				// u tiling of texture
	float vTile;				// v tiling of texture
	float uOffset;			    // u offset of texture
	float vOffset;				// v offset of texture
} ;

// This holds all the information for our model/scene. 
// You should eventually turn into a robust class that 
// has loading/drawing/querying functions like:
// LoadModel(...); DrawObject(...); DrawModel(...); DestroyModel(...);
struct t3DObject 
{
	int  numOfVerts;			// The number of verts in the model
	int  numOfFaces;			// The number of faces in the model
	int  numTexVertex;			// The number of texture coordinates
	int  materialID;			// The texture ID to use, which is the index into our texture array
	bool bHasTexture;			// This is TRUE if there is a texture map for this object
	char strName[255];			// The name of the object
	CVector3  *pVerts;			// The object's vertices
	CVector3  *pNormals;		// The object's normals
	CVector2  *pTexVerts;		// The texture's UV coordinates
	tFace *pFaces;				// The faces information of the object
};

// This holds our model information.
struct t3DModel 
{
	int numOfObjects;					// The number of objects in the model
	int numOfMaterials;					// The number of materials for the model
	vector<tMaterialInfo> pMaterials;	// The list of material information (Textures and colors)
	vector<t3DObject> pObject;			// The object list for our model
};

class ase
{
public:
	
    // This is the only function the client needs to call to load the .ase file
	bool ImportASE(t3DModel *pModel, char *strFileName);

	// This is the main loop that parses the .ase file
	void ReadAseFile(t3DModel *pModel);

	// This returns the number of objects in the .ase file
	int GetObjectCount();

	// This returns the number of materials in the .ase file
	int GetMaterialCount();

	// This fills in the texture information for a desired texture
	void GetTextureInfo (tMaterialInfo *pTexture, int desiredMaterial);

	// This moves our file pointer to the desired object
	void MoveToObject (int desiredObject);

	// This reads in a float from the file
	float ReadFloat();

	// This reads a desired object's information (face, vertex and texture coord counts)
	void ReadObjectInfo(t3DObject *pObject, int desiredObject);

	// This gets the name of the texture
	void GetTextureName (tMaterialInfo  *pTexture);

	// This gets the name of the material
	void GetMaterialName(tMaterialInfo *pTexture);

	// This loads all the data for the desired object
	void ReadObjectData(t3DModel *pModel, t3DObject *pObject, int desiredObject);

	// This is the main load loop inside of ReadObjectData() that calls smaller load functions
	void GetData(t3DModel *pModel, t3DObject *pObject, char *strDesiredData, int desiredObject);

	// This reads in a vertice from the file
	void ReadVertex(t3DObject *pObject);

	// This reads in a texture coordinate from the file
	void ReadTextureVertex(t3DObject *pObject, tMaterialInfo texture);

	// This reads in the vertex indices for a face
	void ReadFace(t3DObject *pObject);

	// This reads in texture coordinate indices for a face
	void ReadTextureFace(t3DObject *pObject);

	// This computes the vertex normals for our objects
	void ComputeNormals(t3DModel *pModel);


private:
	
	// This is our file pointer to load the .ase file
	FILE *m_FilePointer;
	
	     };
      
    
class load
  {
  public:

  	// This creates a texture and stores it in the texture array with it's ID.
    void CreateTexture(UINT textureArray[], LPSTR strFileName, int textureID);
	void Init();
	void RenderScene(int nr);
 };

     
 #endif
